@DATABASE "pExec/Device.h"
@MASTER   "Work2:AD/IInc/pExec/Device.h"
@REMARK   This file was created by ADtoHT 2.0 on 11-Mr-97  13:34:23
@REMARK   Do not edit
@REMARK   ADtoHT is  1993-1995 Christian Stieber

@NODE MAIN "pExec/Device.h"
@TOC "__pOS_Dev.guide/MAIN"

@{"pExec/Device.h" LINK File}


@{b}Structures@{ub}

@{"pOS_Device" LINK "pExec/Device.h/File" 21}  @{"pOS_IORequest" LINK "pExec/Device.h/File" 53}  @{"pOS_IOStdReq" LINK "pExec/Device.h/File" 66}  @{"pOS_StdDeviceFunction" LINK "pExec/Device.h/File" 138}
@{"pOS_Unit" LINK "pExec/Device.h/File" 29}    


@{b}#defines@{ub}

@{"_pOS_GetDeviceFunction()" LINK "pExec/Device.h/File" 161}  @{"_pOS_GetStdDeviceFunction()" LINK "pExec/Device.h/File" 158}

@ENDNODE
@NODE File "pExec/Device.h"
#ifndef __INC_POS_PEXEC_DEVICE_H
#define __INC_POS_PEXEC_DEVICE_H
/*******************************************************************
 Includes Release 24
 (C) Copyright 1995-1997 proDAD
     All Rights Reserved

 $AUT Holger Burkarth
 $DAT >>Device.h<<   09 Nov 1996    19:07:27 - (C) ProDAD
*******************************************************************/
#ifndef __INC_POS_PEXEC_LIBRARY_H
#include <@{"pExec/Library.h" LINK "pExec/Library.h/File"}>
#endif
#ifndef __INC_POS_PEXEC_MSGPORT_H
#include <@{"pExec/MsgPort.h" LINK "pExec/MsgPort.h/File"}>
#endif


/*----------------------------------
-----------------------------------*/
struct pOS_Device
{
  @{"struct pOS_Library" LINK "pExec/Library.h/File" 26} dd_Library;
};


/*----------------------------------
-----------------------------------*/
struct pOS_Unit
{
  @{"struct pOS_MsgPort" LINK "pExec/MsgPort.h/File" 18} unit_MsgPort; /* queue for unprocessed messages */
                            /* instance of msgport is recommended */
  @{"UBYTE" LINK "pExec/Types.h/File" 95}   unit_Flags;
  @{"UBYTE" LINK "pExec/Types.h/File" 95}   unit_Num;         /* kann vom Device fr eigene Zwecke verwendet werden */
  @{"UWORD" LINK "pExec/Types.h/File" 93}   unit_OpenCnt;     /* number of active opens */
};


enum pOS_UnitFlags
{
  UNITF_Active  =0x01, /* BeginIO-Task is working */
  UNITF_InTask  =0x02, /* Unit-Task is working */
  UNITF_Quit    =0x04, /* quit Unit-Task */
  UNITF_Stopped =0x08, /* Unit-Task is CMD_STOP */
  UNITF_NeedSig =0x10, /* Unit-Task need WackUp-Signal */
};




/*----------------------------------
-----------------------------------*/
struct pOS_IORequest
{
  @{"struct pOS_Message" LINK "pExec/MsgPort.h/File" 41}  io_Message;
  @{"struct pOS_Device" LINK File 21}  *io_Device;   /* device node pointer  */
  @{"struct pOS_Unit" LINK File 29}    *io_Unit;     /* unit (driver private) */
  @{"UWORD" LINK "pExec/Types.h/File" 93}               io_Command;   /* (enum pOS_IOReqCommands) */
  @{"UBYTE" LINK "pExec/Types.h/File" 95}               io_Flags;     /* (enum pOS_IOReqFlags) */
  @{"SBYTE" LINK "pExec/Types.h/File" 94}               io_Error;     /* (enum pOS_IOReqErrors) */
};


/*----------------------------------
-----------------------------------*/
struct pOS_IOStdReq
{
  @{"struct pOS_Message" LINK "pExec/MsgPort.h/File" 41}  io_Message;
  @{"struct pOS_Device" LINK File 21}  *io_Device;   /* device node pointer  */
  @{"struct pOS_Unit" LINK File 29}    *io_Unit;     /* unit (driver private)*/
  @{"UWORD" LINK "pExec/Types.h/File" 93}               io_Command;   /* (enum pOS_IOReqCommands) */
  @{"UBYTE" LINK "pExec/Types.h/File" 95}               io_Flags;     /* (enum pOS_IOReqFlags) */
  @{"SBYTE" LINK "pExec/Types.h/File" 94}               io_Error;     /* (enum pOS_IOReqErrors) */
  @{"ULONG" LINK "pExec/Types.h/File" 91}               io_Actual;    /* actual number of bytes transferred */
  @{"ULONG" LINK "pExec/Types.h/File" 91}               io_Length;    /* requested number bytes transferred */
  @{"APTR" LINK "pExec/Types.h/File" 87}                io_Data;      /* points to data area */
  @{"ULONG" LINK "pExec/Types.h/File" 91}               io_Offset;    /* offset for block structured devices */
  @{"ULONG" LINK "pExec/Types.h/File" 91}               io_OPad;
  @{"UBYTE" LINK "pExec/Types.h/File" 95}               io_Pad[8];
};





enum pOS_IOReqFlags
{
  IOREQB_Quick   = 0,

  IOREQF_Quick   = 0x01,
  IOREQF_IntSig  = 0x02, /* fr Device-eigene interne Zwecke */

  IOREQF_Pending = 0x80,
};


enum pOS_IOReqErrors
{
  IOERR_None       = 0,
  IOERR_OpenFail   =-1, /* device/unit failed to open */
  IOERR_Aborted    =-2, /* request terminated early [after AbortIO()] */
  IOERR_NoCMD      =-3, /* command not supported by device */
  IOERR_BadLength  =-4, /* not a valid length (usually IO_LENGTH) */
  IOERR_BadAddress =-5, /* invalid address (misaligned or bad range) */
  IOERR_UnitBusy   =-6, /* device opens ok, but requested unit is busy */
  IOERR_Selftest   =-7, /* hardware failed self-test */
  IOERR_NoMem      =-8, /* not enough memory */
  IOERR_NoSubCMD   =-9  /* sub-command not supported by device */
};


enum pOS_IOReqCommands
{
  CMD_INVALID   = 0,
  CMD_RESET     = 1,
  CMD_READ      = 2,
  CMD_WRITE     = 3,
  CMD_UPDATE    = 4,
  CMD_CLEAR     = 5,
  CMD_STOP      = 6,
  CMD_START     = 7,
  CMD_FLUSH     = 8,

  CMD_NONSTD    = 9,
};








/*----------------------------------
 Rckwrtsgerichtete Struktur, DevBase
 steht auf das Ende der Struct.
-----------------------------------*/
struct pOS_StdDeviceFunction
{
  @{"struct pOS_LibraryFunction" LINK "pExec/Library.h/File" 17} Reserved2[8];

  @{"VOID" LINK "pExec/Types.h/File" 83}  (*AbortIO_func)(@{"_R_LB" LINK "pExec/Types.h/File" 35} @{"struct pOS_Device" LINK File 21}*,_R_A0 struct pOS_IORequest*);
  @{"UBYTE" LINK "pExec/Types.h/File" 95} _d5[8];
  @{"VOID" LINK "pExec/Types.h/File" 83}  (*BeginIO_func)(@{"_R_LB" LINK "pExec/Types.h/File" 35} @{"struct pOS_Device" LINK File 21}*,_R_A0 struct pOS_IORequest*);
  @{"UBYTE" LINK "pExec/Types.h/File" 95} _d4[8];

  @{"struct pOS_LibraryFunction" LINK "pExec/Library.h/File" 17} Reserved1[8];

  @{"struct pOS_SegmentLst" LINK "pDOS/Segment.h/File" 32}* (*Expunge_func)(@{"_R_LB" LINK "pExec/Types.h/File" 35} @{"struct pOS_Device" LINK File 21}*);
  @{"UBYTE" LINK "pExec/Types.h/File" 95} _d3[8];
  @{"VOID" LINK "pExec/Types.h/File" 83}  (*Close_func)(@{"_R_LB" LINK "pExec/Types.h/File" 35} @{"struct pOS_Device" LINK File 21}*,_R_A0 struct pOS_IORequest*);
  @{"UBYTE" LINK "pExec/Types.h/File" 95} _d2[8];
  @{"BOOL" LINK "pExec/Types.h/File" 99}  (*Open_func)(@{"_R_LB" LINK "pExec/Types.h/File" 35} @{"struct pOS_Device" LINK File 21}*,_R_A0 struct pOS_IORequest*,_R_D0 ULONG unitNr,_R_D1 ULONG flags);
  @{"UBYTE" LINK "pExec/Types.h/File" 95} _d1[8];
}; /* => DeviceBase */


#define _pOS_GetStdDeviceFunction(dev) \\
 ( (@{"struct pOS_StdDeviceFunction" LINK File 138}*)((@{"ULONG" LINK "pExec/Types.h/File" 91})(dev) - sizeof(@{"struct pOS_StdDeviceFunction" LINK File 138})) )

#define _pOS_GetDeviceFunction(dev,index) \\
 ( (@{"struct pOS_LibraryFunction" LINK "pExec/Library.h/File" 17}*)((@{"ULONG" LINK "pExec/Types.h/File" 91})(dev) - (index)*sizeof(@{"struct pOS_LibraryFunction" LINK "pExec/Library.h/File" 17})) )



#endif
@ENDNODE
